Index: uspace/lib/ui/src/popup.c
===================================================================
--- uspace/lib/ui/src/popup.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/src/popup.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,218 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Popup window
+ */
+
+#include <errno.h>
+#include <gfx/context.h>
+//#include <io/kbd_event.h>
+#include <io/pos_event.h>
+#include <mem.h>
+#include <stdlib.h>
+#include <ui/control.h>
+#include <ui/popup.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+#include "../private/popup.h"
+
+static void ui_popup_window_close(ui_window_t *, void *);
+static void ui_popup_window_pos(ui_window_t *, void *, pos_event_t *);
+
+static ui_window_cb_t ui_popup_window_cb = {
+	.close = ui_popup_window_close,
+	.pos = ui_popup_window_pos
+};
+
+/** Initialize popup parameters structure.
+ *
+ * Popup parameters structure must always be initialized using this function
+ * first.
+ *
+ * @param params Popup parameters structure
+ */
+void ui_popup_params_init(ui_popup_params_t *params)
+{
+	memset(params, 0, sizeof(ui_popup_params_t));
+}
+
+/** Create new popup window.
+ *
+ * @param ui User interface
+ * @param parent Parent window
+ * @param params Popup parameters
+ * @param rpopup Place to store pointer to new popup window
+ * @return EOK on success or an error code
+ */
+errno_t ui_popup_create(ui_t *ui, ui_window_t *parent,
+    ui_popup_params_t *params, ui_popup_t **rpopup)
+{
+	ui_popup_t *popup;
+	ui_window_t *window = NULL;
+	ui_wnd_params_t wparams;
+	gfx_coord2_t parent_pos;
+	errno_t rc;
+
+	popup = calloc(1, sizeof(ui_popup_t));
+	if (popup == NULL)
+		return ENOMEM;
+
+	rc = ui_window_get_pos(parent, &parent_pos);
+	if (rc != EOK)
+		goto error;
+
+	ui_wnd_params_init(&wparams);
+	wparams.rect = params->rect;
+	wparams.caption = "";
+	wparams.style &= ~ui_wds_decorated;
+	wparams.placement = ui_wnd_place_popup;
+	wparams.flags |= ui_wndf_popup;
+
+	/* Compute position of parent rectangle relative to the screen */
+	gfx_rect_translate(&parent_pos, &params->place, &wparams.prect);
+
+	rc = ui_window_create(ui, &wparams, &window);
+	if (rc != EOK)
+		goto error;
+
+	popup->ui = ui;
+	popup->parent = parent;
+	popup->window = window;
+
+	ui_window_set_cb(window, &ui_popup_window_cb, popup);
+
+	*rpopup = popup;
+	return EOK;
+error:
+	free(popup);
+	return rc;
+}
+
+/** Destroy popup window.
+ *
+ * @param popup Popup window or @c NULL
+ */
+void ui_popup_destroy(ui_popup_t *popup)
+{
+	if (popup == NULL)
+		return;
+
+	ui_window_destroy(popup->window);
+	free(popup);
+}
+
+/** Add control to popup window.
+ *
+ * Only one control can be added to a popup window. If more than one control
+ * is added, the results are undefined.
+ *
+ * @param popup Popup window
+ * @param control Control
+ * @return EOK on success, ENOMEM if out of memory
+ */
+void ui_popup_add(ui_popup_t *popup, ui_control_t *control)
+{
+	ui_window_add(popup->window, control);
+}
+
+/** Remove control from popup window.
+ *
+ * @param popup Popup window
+ * @param control Control
+ */
+void ui_popup_remove(ui_popup_t *popup, ui_control_t *control)
+{
+	ui_window_remove(popup->window, control);
+}
+
+/** Set popup window callbacks.
+ *
+ * @param popup Popup window
+ * @param cb Popup window callbacks
+ * @param arg Callback argument
+ */
+void ui_popup_set_cb(ui_popup_t *popup, ui_popup_cb_t *cb, void *arg)
+{
+	popup->cb = cb;
+	popup->arg = arg;
+}
+
+/** Get UI resource from popup window.
+ *
+ * @param window Window
+ * @return UI resource
+ */
+ui_resource_t *ui_popup_get_res(ui_popup_t *popup)
+{
+	return ui_window_get_res(popup->window);
+}
+
+/** Get popup window GC.
+ *
+ * @param popup Popup window
+ * @return GC (relative to popup window)
+ */
+gfx_context_t *ui_popup_get_gc(ui_popup_t *popup)
+{
+	return ui_window_get_gc(popup->window);
+}
+
+/** Handle close event in popup window.
+ *
+ * @param window Window
+ * @param arg Argument (ui_popup_t *)
+ */
+static void ui_popup_window_close(ui_window_t *window, void *arg)
+{
+	ui_popup_t *popup = (ui_popup_t *)arg;
+
+	if (popup->cb != NULL && popup->cb->close != NULL)
+		popup->cb->close(popup, popup->arg);
+}
+
+/** Handle position event in popup window.
+ *
+ * @param window Window
+ * @param arg Argument (ui_popup_t *)
+ * @param event Position event
+ */
+static void ui_popup_window_pos(ui_window_t *window, void *arg,
+    pos_event_t *event)
+{
+	ui_popup_t *popup = (ui_popup_t *)arg;
+
+	if (popup->cb != NULL && popup->cb->pos != NULL)
+		popup->cb->pos(popup, popup->arg, event);
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/rbutton.c
===================================================================
--- uspace/lib/ui/src/rbutton.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/src/rbutton.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,471 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Radio button
+ */
+
+#include <errno.h>
+#include <gfx/color.h>
+#include <gfx/context.h>
+#include <gfx/render.h>
+#include <gfx/text.h>
+#include <io/pos_event.h>
+#include <stdlib.h>
+#include <str.h>
+#include <ui/control.h>
+#include <ui/paint.h>
+#include <ui/rbutton.h>
+#include "../private/rbutton.h"
+#include "../private/resource.h"
+
+enum {
+	rbutton_oframe_r = 7,
+	rbutton_iframe_r = 6,
+	rbutton_interior_r = 5,
+	rbutton_indicator_r = 3,
+	rbutton_label_margin = 8
+};
+
+static void ui_rbutton_ctl_destroy(void *);
+static errno_t ui_rbutton_ctl_paint(void *);
+static ui_evclaim_t ui_rbutton_ctl_pos_event(void *, pos_event_t *);
+
+/** Radio button control ops */
+ui_control_ops_t ui_rbutton_ops = {
+	.destroy = ui_rbutton_ctl_destroy,
+	.paint = ui_rbutton_ctl_paint,
+	.pos_event = ui_rbutton_ctl_pos_event
+};
+
+/** Create new radio button group.
+ *
+ * @param res UI resource
+ * @param rgroup Place to store pointer to new radio button group
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_rbutton_group_create(ui_resource_t *res, ui_rbutton_group_t **rgroup)
+{
+	ui_rbutton_group_t *group;
+
+	group = calloc(1, sizeof(ui_rbutton_group_t));
+	if (group == NULL)
+		return ENOMEM;
+
+	group->res = res;
+	*rgroup = group;
+	return EOK;
+}
+
+/** Destroy radio button group.
+ *
+ * @param group Radio button group or @c NULL
+ */
+void ui_rbutton_group_destroy(ui_rbutton_group_t *group)
+{
+	if (group == NULL)
+		return;
+
+	free(group);
+}
+
+/** Create new radio button.
+ *
+ * @param group Radio button group
+ * @param caption Caption
+ * @param arg Callback argument
+ * @param rrbutton Place to store pointer to new radio button
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_rbutton_create(ui_rbutton_group_t *group, const char *caption,
+    void *arg, ui_rbutton_t **rrbutton)
+{
+	ui_rbutton_t *rbutton;
+	errno_t rc;
+
+	rbutton = calloc(1, sizeof(ui_rbutton_t));
+	if (rbutton == NULL)
+		return ENOMEM;
+
+	rc = ui_control_new(&ui_rbutton_ops, (void *) rbutton,
+	    &rbutton->control);
+	if (rc != EOK) {
+		free(rbutton);
+		return rc;
+	}
+
+	rbutton->caption = str_dup(caption);
+	if (rbutton->caption == NULL) {
+		ui_control_delete(rbutton->control);
+		free(rbutton);
+		return ENOMEM;
+	}
+
+	rbutton->group = group;
+	rbutton->arg = arg;
+
+	if (group->selected == NULL)
+		group->selected = rbutton;
+
+	*rrbutton = rbutton;
+	return EOK;
+}
+
+/** Destroy radio button.
+ *
+ * @param rbutton Radio button or @c NULL
+ */
+void ui_rbutton_destroy(ui_rbutton_t *rbutton)
+{
+	if (rbutton == NULL)
+		return;
+
+	ui_control_delete(rbutton->control);
+	free(rbutton);
+}
+
+/** Get base control from radio button.
+ *
+ * @param rbutton Radio button
+ * @return Control
+ */
+ui_control_t *ui_rbutton_ctl(ui_rbutton_t *rbutton)
+{
+	return rbutton->control;
+}
+
+/** Set radio button group callbacks.
+ *
+ * @param group Radio button group
+ * @param cb Radio button group callbacks
+ * @param arg Callback argument
+ */
+void ui_rbutton_group_set_cb(ui_rbutton_group_t *group,
+    ui_rbutton_group_cb_t *cb, void *arg)
+{
+	group->cb = cb;
+	group->arg = arg;
+}
+
+/** Set button rectangle.
+ *
+ * @param rbutton Button
+ * @param rect New button rectangle
+ */
+void ui_rbutton_set_rect(ui_rbutton_t *rbutton, gfx_rect_t *rect)
+{
+	rbutton->rect = *rect;
+}
+
+/** Paint radio button.
+ *
+ * @param rbutton Radio button
+ * @return EOK on success or an error code
+ */
+errno_t ui_rbutton_paint(ui_rbutton_t *rbutton)
+{
+	gfx_coord2_t pos;
+	gfx_coord2_t center;
+	gfx_text_fmt_t fmt;
+	bool depressed;
+	errno_t rc;
+
+	center.x = rbutton->rect.p0.x + rbutton_oframe_r;
+	center.y = rbutton->rect.p0.y + rbutton_oframe_r;
+
+	/* Paint rbutton frame */
+
+	rc = gfx_set_color(rbutton->group->res->gc,
+	    rbutton->group->res->wnd_shadow_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_paint_filled_circle(rbutton->group->res->gc,
+	    &center, rbutton_oframe_r, ui_fcircle_upleft);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_set_color(rbutton->group->res->gc,
+	    rbutton->group->res->wnd_highlight_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_paint_filled_circle(rbutton->group->res->gc,
+	    &center, rbutton_oframe_r, ui_fcircle_lowright);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_set_color(rbutton->group->res->gc,
+	    rbutton->group->res->wnd_frame_sh_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_paint_filled_circle(rbutton->group->res->gc,
+	    &center, rbutton_iframe_r, ui_fcircle_upleft);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_set_color(rbutton->group->res->gc,
+	    rbutton->group->res->wnd_face_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_paint_filled_circle(rbutton->group->res->gc,
+	    &center, rbutton_iframe_r, ui_fcircle_lowright);
+	if (rc != EOK)
+		goto error;
+
+	/* Paint rbutton interior */
+	depressed = rbutton->held && rbutton->inside;
+
+	rc = gfx_set_color(rbutton->group->res->gc, depressed ?
+	    rbutton->group->res->entry_act_bg_color :
+	    rbutton->group->res->entry_bg_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_paint_filled_circle(rbutton->group->res->gc,
+	    &center, rbutton_interior_r, ui_fcircle_entire);
+	if (rc != EOK)
+		goto error;
+
+	/* Paint active mark */
+
+	if (rbutton->group->selected == rbutton) {
+		rc = gfx_set_color(rbutton->group->res->gc,
+		    rbutton->group->res->entry_fg_color);
+		if (rc != EOK)
+			goto error;
+
+		rc = ui_paint_filled_circle(rbutton->group->res->gc,
+		    &center, rbutton_indicator_r, ui_fcircle_entire);
+		if (rc != EOK)
+			goto error;
+	}
+
+	/* Paint rbutton label */
+
+	pos.x = center.x + rbutton_oframe_r + rbutton_label_margin;
+	pos.y = center.y;
+
+	gfx_text_fmt_init(&fmt);
+	fmt.color = rbutton->group->res->wnd_text_color;
+	fmt.halign = gfx_halign_left;
+	fmt.valign = gfx_valign_center;
+
+	rc = gfx_puttext(rbutton->group->res->font, &pos, &fmt,
+	    rbutton->caption);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_update(rbutton->group->res->gc);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Press down button.
+ *
+ * @param rbutton Radio button
+ */
+void ui_rbutton_press(ui_rbutton_t *rbutton)
+{
+	if (rbutton->held)
+		return;
+
+	rbutton->inside = true;
+	rbutton->held = true;
+	(void) ui_rbutton_paint(rbutton);
+}
+
+/** Release button.
+ *
+ * @param rbutton Radio button
+ */
+void ui_rbutton_release(ui_rbutton_t *rbutton)
+{
+	if (!rbutton->held)
+		return;
+
+	rbutton->held = false;
+
+	if (rbutton->inside) {
+		/* Activate radio button */
+		ui_rbutton_select(rbutton);
+	}
+}
+
+/** Pointer entered button.
+ *
+ * @param rbutton Radio button
+ */
+void ui_rbutton_enter(ui_rbutton_t *rbutton)
+{
+	if (rbutton->inside)
+		return;
+
+	rbutton->inside = true;
+	if (rbutton->held)
+		(void) ui_rbutton_paint(rbutton);
+}
+
+/** Pointer left button.
+ *
+ * @param rbutton Radio button
+ */
+void ui_rbutton_leave(ui_rbutton_t *rbutton)
+{
+	if (!rbutton->inside)
+		return;
+
+	rbutton->inside = false;
+	if (rbutton->held)
+		(void) ui_rbutton_paint(rbutton);
+}
+
+/** Select radio button.
+ *
+ * @param rbutton Radio button
+ */
+void ui_rbutton_select(ui_rbutton_t *rbutton)
+{
+	ui_rbutton_t *old_selected;
+
+	old_selected = rbutton->group->selected;
+
+	if (old_selected != rbutton) {
+		rbutton->group->selected = rbutton;
+		ui_rbutton_paint(old_selected);
+	}
+
+	/* Repaint and notify */
+	(void) ui_rbutton_paint(rbutton);
+
+	if (old_selected != rbutton)
+		ui_rbutton_selected(rbutton);
+}
+
+/** Notify that button was selected.
+ *
+ * @param rbutton Radio button
+ */
+void ui_rbutton_selected(ui_rbutton_t *rbutton)
+{
+	ui_rbutton_group_t *group = rbutton->group;
+
+	if (group->cb != NULL && group->cb->selected != NULL) {
+		group->cb->selected(group, group->arg, rbutton->arg);
+	}
+}
+
+/** Handle radio button position event.
+ *
+ * @param rbutton Radio button
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_rbutton_pos_event(ui_rbutton_t *rbutton, pos_event_t *event)
+{
+	gfx_coord2_t pos;
+	bool inside;
+
+	pos.x = event->hpos;
+	pos.y = event->vpos;
+
+	inside = gfx_pix_inside_rect(&pos, &rbutton->rect);
+
+	switch (event->type) {
+	case POS_PRESS:
+		if (inside) {
+			ui_rbutton_press(rbutton);
+			return ui_claimed;
+		}
+		break;
+	case POS_RELEASE:
+		if (rbutton->held) {
+			ui_rbutton_release(rbutton);
+			return ui_claimed;
+		}
+		break;
+	case POS_UPDATE:
+		if (inside && !rbutton->inside) {
+			ui_rbutton_enter(rbutton);
+			return ui_claimed;
+		} else if (!inside && rbutton->inside) {
+			ui_rbutton_leave(rbutton);
+		}
+		break;
+	}
+
+	return ui_unclaimed;
+}
+
+/** Destroy radio button control.
+ *
+ * @param arg Argument (ui_rbutton_t *)
+ */
+void ui_rbutton_ctl_destroy(void *arg)
+{
+	ui_rbutton_t *rbutton = (ui_rbutton_t *) arg;
+
+	ui_rbutton_destroy(rbutton);
+}
+
+/** Paint radio button control.
+ *
+ * @param arg Argument (ui_rbutton_t *)
+ * @return EOK on success or an error code
+ */
+errno_t ui_rbutton_ctl_paint(void *arg)
+{
+	ui_rbutton_t *rbutton = (ui_rbutton_t *) arg;
+
+	return ui_rbutton_paint(rbutton);
+}
+
+/** Handle radio button control position event.
+ *
+ * @param arg Argument (ui_rbutton_t *)
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_rbutton_ctl_pos_event(void *arg, pos_event_t *event)
+{
+	ui_rbutton_t *rbutton = (ui_rbutton_t *) arg;
+
+	return ui_rbutton_pos_event(rbutton, event);
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/resource.c
===================================================================
--- uspace/lib/ui/src/resource.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/src/resource.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -50,8 +50,10 @@
  *
  * @param gc Graphic context
+ * @param textmode @c true if running in text mode
  * @param rresource Place to store pointer to new UI resource
  * @return EOK on success, ENOMEM if out of memory
  */
-errno_t ui_resource_create(gfx_context_t *gc, ui_resource_t **rresource)
+errno_t ui_resource_create(gfx_context_t *gc, bool textmode,
+    ui_resource_t **rresource)
 {
 	ui_resource_t *resource;
@@ -66,4 +68,6 @@
 	gfx_color_t *wnd_face_color = NULL;
 	gfx_color_t *wnd_text_color = NULL;
+	gfx_color_t *wnd_sel_text_color = NULL;
+	gfx_color_t *wnd_sel_text_bg_color = NULL;
 	gfx_color_t *wnd_frame_hi_color = NULL;
 	gfx_color_t *wnd_frame_sh_color = NULL;
@@ -76,4 +80,5 @@
 	gfx_color_t *entry_fg_color = NULL;
 	gfx_color_t *entry_bg_color = NULL;
+	gfx_color_t *entry_act_bg_color = NULL;
 	errno_t rc;
 
@@ -82,17 +87,28 @@
 		return ENOMEM;
 
-	rc = gfx_typeface_open(gc, ui_typeface_path, &tface);
-	if (rc != EOK)
-		goto error;
-
-	finfo = gfx_typeface_first_font(tface);
-	if (finfo == NULL) {
-		rc = EIO;
-		goto error;
+	if (textmode) {
+		/* Create dummy font for text mode */
+		rc = gfx_typeface_create(gc, &tface);
+		if (rc != EOK)
+			goto error;
+
+		rc = gfx_font_create_textmode(tface, &font);
+		if (rc != EOK)
+			goto error;
+	} else {
+		rc = gfx_typeface_open(gc, ui_typeface_path, &tface);
+		if (rc != EOK)
+			goto error;
+
+		finfo = gfx_typeface_first_font(tface);
+		if (finfo == NULL) {
+			rc = EIO;
+			goto error;
+		}
+
+		rc = gfx_font_open(finfo, &font);
+		if (rc != EOK)
+			goto error;
 	}
-
-	rc = gfx_font_open(finfo, &font);
-	if (rc != EOK)
-		goto error;
 
 	rc = gfx_color_new_rgb_i16(0, 0, 0, &btn_frame_color);
@@ -125,9 +141,18 @@
 		goto error;
 
+	rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff, &wnd_sel_text_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_rgb_i16(0x5858, 0x6a6a, 0xc4c4,
+	    &wnd_sel_text_bg_color);
+	if (rc != EOK)
+		goto error;
+
 	rc = gfx_color_new_rgb_i16(0x8888, 0x8888, 0x8888, &wnd_frame_hi_color);
 	if (rc != EOK)
 		goto error;
 
-	rc = gfx_color_new_rgb_i16(0, 0, 0, &wnd_frame_sh_color);
+	rc = gfx_color_new_rgb_i16(0x4444, 0x4444, 0x4444, &wnd_frame_sh_color);
 	if (rc != EOK)
 		goto error;
@@ -166,4 +191,8 @@
 
 	rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff, &entry_bg_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_rgb_i16(0xc8c8, 0xc8c8, 0xc8c8, &entry_act_bg_color);
 	if (rc != EOK)
 		goto error;
@@ -172,4 +201,5 @@
 	resource->tface = tface;
 	resource->font = font;
+	resource->textmode = textmode;
 
 	resource->btn_frame_color = btn_frame_color;
@@ -181,4 +211,6 @@
 	resource->wnd_face_color = wnd_face_color;
 	resource->wnd_text_color = wnd_text_color;
+	resource->wnd_sel_text_color = wnd_sel_text_color;
+	resource->wnd_sel_text_bg_color = wnd_sel_text_bg_color;
 	resource->wnd_frame_hi_color = wnd_frame_hi_color;
 	resource->wnd_frame_sh_color = wnd_frame_sh_color;
@@ -193,4 +225,5 @@
 	resource->entry_fg_color = entry_fg_color;
 	resource->entry_bg_color = entry_bg_color;
+	resource->entry_act_bg_color = entry_act_bg_color;
 
 	*rresource = resource;
@@ -212,4 +245,8 @@
 	if (wnd_text_color != NULL)
 		gfx_color_delete(wnd_text_color);
+	if (wnd_sel_text_color != NULL)
+		gfx_color_delete(wnd_sel_text_color);
+	if (wnd_sel_text_bg_color != NULL)
+		gfx_color_delete(wnd_sel_text_bg_color);
 	if (wnd_frame_hi_color != NULL)
 		gfx_color_delete(wnd_frame_hi_color);
@@ -234,4 +271,6 @@
 	if (entry_bg_color != NULL)
 		gfx_color_delete(entry_bg_color);
+	if (entry_act_bg_color != NULL)
+		gfx_color_delete(entry_act_bg_color);
 
 	if (tface != NULL)
@@ -258,4 +297,6 @@
 	gfx_color_delete(resource->wnd_face_color);
 	gfx_color_delete(resource->wnd_text_color);
+	gfx_color_delete(resource->wnd_sel_text_color);
+	gfx_color_delete(resource->wnd_sel_text_bg_color);
 	gfx_color_delete(resource->wnd_frame_hi_color);
 	gfx_color_delete(resource->wnd_frame_sh_color);
@@ -270,4 +311,5 @@
 	gfx_color_delete(resource->entry_fg_color);
 	gfx_color_delete(resource->entry_bg_color);
+	gfx_color_delete(resource->entry_act_bg_color);
 
 	gfx_font_close(resource->font);
@@ -276,4 +318,32 @@
 }
 
+/** Set UI resource expose callback.
+ *
+ * @param resource Resource
+ * @param cb Callback
+ * @param arg Callback argument
+ */
+void ui_resource_set_expose_cb(ui_resource_t *resource,
+    ui_expose_cb_t cb, void *arg)
+{
+	resource->expose_cb = cb;
+	resource->expose_arg = arg;
+}
+
+/** Force UI repaint after an area has been exposed.
+ *
+ * This is called when a popup disappears, which could have exposed some
+ * other UI elements. It causes complete repaint of the UI.
+ *
+ * NOTE Ideally we could specify the exposed rectangle and then limit
+ * the repaint to just that. That would, however, require means of
+ * actually clipping the repaint operation.
+ */
+void ui_resource_expose(ui_resource_t *resource)
+{
+	if (resource->expose_cb != NULL)
+		resource->expose_cb(resource->expose_arg);
+}
+
 /** @}
  */
